#! /bin/bash

# Copyright (c) 2020, The Open Effects Association Ltd. All rights reserved.

# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:

#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright notice,
#       this list of conditions and the following disclaimer in the documentation
#       and/or other materials provided with the distribution.
#     * Neither the name The Open Effects Association Ltd, nor the names of its
#       contributors may be used to endorse or promote products derived from this
#       software without specific prior written permission.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
# ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#########################
# Build OFX documentation
#########################

set -e
trap 'catch $? $LINENO' err

catch() {
    echo "ERROR code $1 on line $2"
    exit 1
}

# Check for prereqs

if [ ! -f genPropertiesReference.py ] ; then
    echo "This script must be run in the Documentation directory."
    exit 1
fi

if ! command -v sphinx-build > /dev/null 2>&1 ; then
    echo "Python can't import required modules; did you set up the prereqs?"
    echo "Check the README.md."
    exit 1
fi

rm -rf build

# Generate references
EXPECTED_ERRS="unable to resolve reference|explicit link request|found in multiple"
python genPropertiesReference.py \
       -i ../include -o sources/Reference/ofxPropertiesReference.rst -r \
       > /tmp/ofx-doc-build.out 2>&1
egrep -v "$EXPECTED_ERRS" /tmp/ofx-doc-build.out || true

# Build the Doxygen docs
EXPECTED_ERRS="malformed hyperlink target|Duplicate explicit|Definition list ends|unable to resolve|could not be resolved"
cd ../include
doxygen ofx.doxy > /tmp/ofx-doc-build.out 2>&1
egrep -v "$EXPECTED_ERRS" /tmp/ofx-doc-build.out || true
cd -

# Build the Sphinx docs
EXPECTED_ERRS="Explicit markup ends without|Duplicate declaration|cpp:func targets a member|undefined label"
sphinx-build -b html sources build > /tmp/ofx-doc-build.out 2>&1
egrep -v "$EXPECTED_ERRS" /tmp/ofx-doc-build.out || true

echo "Documentation build complete."
echo "Open file:///$PWD/build/index.html in your browser"
echo "to check."

# end of build.sh
